#!/bin/bash
# MPKG manager for E6/A1200 by yan0, 2006/06/02
# modified for admincontrols

export QTDIR=/usr/lib/ezx
. /home/native/.profile

myfile=`basename $0`
mypath=`echo $0 | sed -e 's/'$myfile'//g'`
mpkg_file="$2"
pkgfile=`basename $2`

if [ -d /diska ]
then
	mmsg=`showQ -u -1 "Ok" -2 "" -s "Dialog_Exclamatory_Mark" -m "Only for A1200/E6!"`
	exit
fi

card='/mmc/mmca1/.system/java/CardRegistry'
mpkg_path='/mmc/mmca1/.system/QTDownLoad'
work_path='/mmc/mmca1/.system/QTDownLoad'

cd $work_path
rm -f -R yan0
mkdir yan0
cd yan0

mmsg=`showQ -u -1 "Yes" -2 "No" -g "$mypath../icons/setup.png" -m "Install:
$pkgfile?"`
if [ "$mmsg" = "1" ]
then
	cd $work_path
	rm -f -R yan0
	exit
fi
if [ "$mmsg" = "0" ]
then
	showQ -u -1 "" -m "Installing, please wait..." & 
	sleep 1s
	if tar -tvf "$mpkg_file" >/dev/null
	then
		tar -xf "$mpkg_file"
		fflag="ok"
	else
		if tar -tzvf "$mpkg_file" > /dev/null
		then
			tar -xzf "$mpkg_file"
			fflag="ok"
		fi
	fi
	
	if [ $fflag = "ok" ]
	then
		echo "error" > fflag.tmp
		dir -1 |while read mpkg
		do
			if [ -d "$mpkg" ]
			then
				if [ -d "$mpkg_path/$mpkg" ]
				then
				    start-stop-daemon --start --exec /bin/kill ` pidof showQ `
				    mmsg=`showQ -u -1 "Yes" -2 "No" -g "$mypath/setup.png" -m "$mpkg Exists!

Re-install?"`	
					if [ "$mmsg" = "0" ]
					then
						showQ -u -1 "" -m "reinstalling, please wait..." & 	
						sleep 1s
						cp -fr $mpkg $mpkg_path/
						echo "update" > fflag.tmp
					fi
					if [ "$mmsg" = "1" ]
					then
						showQ -u -1 "" -m "installing, please wait..." & 	
						a=""
						while [ -d "$mpkg_path/$mpkg$a" ] 
						do
							a=$(($a + 1 ))
						done
						mpkg2="$mpkg$a"
						# Get desktop file to begin MPKG configuration	
						cd "$mpkg"
						rm -f contest.desktop
						dir -1 *.desktop |while read desktop_file
						do
							if [ -f "$desktop_file" ]
							then
								cp "$desktop_file" ../"$desktop_file"
								cd ..			
								cp $card db_file
								# Max handle 999 mpkg files. yan0
								appid_0="0bcbe2070"
								appid=$appid_0"002"
								appid_1=$appid"]"
								a='1'
								while [ `grep  "$appid_1" db_file `  ] 
								do
									a=$(($a + 1 ))
									if [ $a -le 9 ]
									then 
										appid=$appid_0"00"$a
										appid_1=$appid"]"
									elif [ $a -le 99 ]
									then 	
										appid=$appid_0"0"$a
										appid_1=$appid"]"
									fi	
								done
								appid="8a2b9b37-83e7-a8d9-82cf-"$appid	
								echo >mpkg.tmp									
								echo "["$appid"]" >>mpkg.tmp
  						
								tstr=`grep -i "^AniIcon" "$desktop_file"`
								if [ $tstr = "" ]
								then
									echo "AniIcon =" >>mpkg.tmp
								else
									tstr=${tstr#*=}
									tstr=`echo $tstr`
									echo "AniIcon = "$tstr >>mpkg.tmp						
								fi
  
								echo "AppID = {"$appid"}" >> mpkg.tmp
								echo "Args =" >>mpkg.tmp 
								echo "Attribute = 4" >>mpkg.tmp
  						
								tstr=`grep -i "^BigIcon" "$desktop_file"`
								tstr=${tstr#*=}
								tstr=`echo $tstr`
								echo "BigIcon = "$tstr >>mpkg.tmp
  						
								echo "Daemon = 0" >>mpkg.tmp					
								echo "Directory = "$mpkg2 >>mpkg.tmp
								echo "Eraseable = 1" >>mpkg.tmp
  						
								tstr=`grep -i "^Exec" "$desktop_file"`
								tstr=${tstr#*=}
								tstr=`echo $tstr`
								echo "Exec = "$tstr >>mpkg.tmp
  						
								echo "FixedAllPosition = 0" >>mpkg.tmp
								echo "FixedPosition = 0" >>mpkg.tmp
								echo "GroupID = ezx" >>mpkg.tmp
  						
								tstr=`grep -i "^Icon" "$desktop_file"`
								tstr=${tstr#*=}
								tstr=`echo $tstr`
								echo "Icon = "$tstr >>mpkg.tmp
  
								dir --full-time mpkg.tmp |while read a a a a a a b c a d a
								do 
									echo $b >2.tmp
									b=`sed -e 's/Jan/01/' -e 's/Feb/02/' -e 's/Mar/03/' -e 's/Apr/04/' -e 's/May/05/' -e 's/Jun/06/' -e 's/Jul/07/' -e 's/Aug/08/' -e 's/Sep/09/' -e 's/Oct/10/' -e 's/Nov/11/' -e 's/Dec/12/' 2.tmp `
									echo "InstalledDate = "$d/$b/$c >>mpkg.tmp
								done			
								echo "JavaId = -1" >>mpkg.tmp
								echo "MassStorageStatus = 0" >>mpkg.tmp
								echo "MpkgFile =" >>mpkg.tmp
								#grep "^[Nn]ame" "$desktop_file" >>mpkg.tmp
								appname=`grep -i "^Name" "$desktop_file"`
								appname=${appname#*=}
								# Trim blank-char of start and end
								appname=`echo $appname`
								echo "Name = "$appname >> mpkg.tmp
								echo $appname > appname.tmp
								tstr=`grep -i "^OsVersion" "$desktop_file"`
								tstr=${tstr#*=}
								tstr=`echo $tstr`
								echo "OsVersion = "$tstr >>mpkg.tmp
  						
								echo "Shared = 0" >>mpkg.tmp
		  						dir -s "$mpkg_file" |while read a b
		  						do
		  							echo "Size = "$a"K" >> mpkg.tmp
		  						done
		  						echo "Type = 2" >>mpkg.tmp
		  						echo "UserID = ezx" >>mpkg.tmp
		  						echo "Visible = 1" >>mpkg.tmp
		  						cat mpkg.tmp >>$card
		  						cp -R "$mpkg" $mpkg_path/"$mpkg2"
		  						echo "ok" > fflag.tmp
							fi
						done
					fi
				else
					# Get the target directory
					a=""
					while [ -d "$mpkg_path/$mpkg$a" ] 
					do
						a=$(($a + 1 ))
					done
	  				mpkg2="$mpkg$a"
	  				# Get desktop file to begin MPKG configuration	
	  				cd "$mpkg"
	  				rm -f contest.desktop
	  				dir -1 *.desktop |while read desktop_file
	  				do
	  					if [ -f "$desktop_file" ]
	  					then
	  						cp "$desktop_file" ../"$desktop_file"
	  						cd ..			
	  						cp $card db_file
	  						# Max handle 999 mpkg files. yan0
	  						appid_0="0bcbe2070"
	  						appid=$appid_0"002"
	  						appid_1=$appid"]"
	  						a='1'
	  						while [ `grep  "$appid_1" db_file `  ] 
	  						do
	  							a=$(($a + 1 ))
	  							if [ $a -le 9 ]
	  							then 
	  								appid=$appid_0"00"$a
	  								appid_1=$appid"]"
	  							elif [ $a -le 99 ]
	  								then 	
	  									appid=$appid_0"0"$a
	  								appid_1=$appid"]"
	  							fi	
	  						done
	  						appid="8a2b9b37-83e7-a8d9-82cf-"$appid	
	  						echo >mpkg.tmp									
	  						echo "["$appid"]" >>mpkg.tmp
	  						
	  						tstr=`grep -i "^AniIcon" "$desktop_file"`
	  						if [ $tstr = "" ]
	  						then
	  							echo "AniIcon =" >>mpkg.tmp
	  						else
	  							tstr=${tstr#*=}
	  							tstr=`echo $tstr`
	  							echo "AniIcon = "$tstr >>mpkg.tmp						
	  						fi
	  
	  						echo "AppID = {"$appid"}" >> mpkg.tmp
	  						echo "Args =" >>mpkg.tmp 
	  						echo "Attribute = 4" >>mpkg.tmp
	  						
	  						tstr=`grep -i "^BigIcon" "$desktop_file"`
	  						tstr=${tstr#*=}
	  						tstr=`echo $tstr`
	  						echo "BigIcon = "$tstr >>mpkg.tmp
	  						
	  						echo "Daemon = 0" >>mpkg.tmp					
	  						echo "Directory = "$mpkg2 >>mpkg.tmp
	  						echo "Eraseable = 1" >>mpkg.tmp
	  						
	  						tstr=`grep -i "^Exec" "$desktop_file"`
	  						tstr=${tstr#*=}
	  						tstr=`echo $tstr`
	  						echo "Exec = "$tstr >>mpkg.tmp
	  						
	  						echo "FixedAllPosition = 0" >>mpkg.tmp
	  						echo "FixedPosition = 0" >>mpkg.tmp
	  						echo "GroupID = ezx" >>mpkg.tmp
	  						
	  						tstr=`grep -i "^Icon" "$desktop_file"`
	  						tstr=${tstr#*=}
	  						tstr=`echo $tstr`
	  						echo "Icon = "$tstr >>mpkg.tmp
	  
	  						dir --full-time mpkg.tmp |while read a a a a a a b c a d a
	  						do 
	  							echo $b >2.tmp
	  							b=`sed -e 's/Jan/01/' -e 's/Feb/02/' -e 's/Mar/03/' -e 's/Apr/04/' -e 's/May/05/' -e 's/Jun/06/' -e 's/Jul/07/' -e 's/Aug/08/' -e 's/Sep/09/' -e 's/Oct/10/' -e 's/Nov/11/' -e 's/Dec/12/' 2.tmp `
	  							echo "InstalledDate = "$d/$b/$c >>mpkg.tmp
	  						done			
	  						echo "JavaId = -1" >>mpkg.tmp
	  						echo "MassStorageStatus = 0" >>mpkg.tmp
	  						echo "MpkgFile =" >>mpkg.tmp
	  						#grep "^[Nn]ame" "$desktop_file" >>mpkg.tmp
	  						appname=`grep -i "^Name" "$desktop_file"`
	  						appname=${appname#*=}
	  						# Trim blank-char of start and end
	  						appname=`echo $appname`
	  						echo "Name = "$appname >> mpkg.tmp
	  						echo $appname > appname.tmp
	  						tstr=`grep -i "^OsVersion" "$desktop_file"`
	  						tstr=${tstr#*=}
	  						tstr=`echo $tstr`
	  						echo "OsVersion = "$tstr >>mpkg.tmp
	  						
	  						echo "Shared = 0" >>mpkg.tmp
	  						dir -s "$mpkg_file" |while read a b
	  						do
	  							echo "Size = "$a"K" >> mpkg.tmp
	  						done
	  						echo "Type = 2" >>mpkg.tmp
	  						echo "UserID = ezx" >>mpkg.tmp
	  						echo "Visible = 1" >>mpkg.tmp
	  						cat mpkg.tmp >>$card
	  						cp -R "$mpkg" $mpkg_path/"$mpkg2"
	  						echo "ok" > fflag.tmp
	  					fi
	  				done				
				fi
			fi
		done
	fi
	fflag=`cat fflag.tmp`
	appname=`cat appname.tmp`
	cd $work_path
	rm -rf yan0

	if [ $fflag = "ok" ]
	then
		start-stop-daemon --start --exec /bin/kill ` pidof showQ `
		mmsg=`showQ -u -1 "Yes" -2 "No" -s "Dialog_Complete" -m "$pkgfile
Installed Successfully!

Reload Menus?"`
		if [ "$mmsg" = "0" ]
		then
				showQ -u -1 "" -m "reloading, please wait..." & 	
				sleep 1s
        /sbin/start-stop-daemon --stop -n am
        start-stop-daemon --start --exec /bin/kill ` pidof showQ `
		else
		fi	
		exit
	else
		if [ $fflag = "update" ]
		then
		start-stop-daemon --start --exec /bin/kill ` pidof showQ `
		mmsg=`showQ -u -1 "Ok" -2 "" -s "Dialog_Complete" -m "$pkgfile
Reinstalled Successfully!"`
		else
		start-stop-daemon --start --exec /bin/kill ` pidof showQ `
		mmsg=`showQ -u -1 "Ok" -2 "" -s "Dialog_Error" -m "Non standard MPKG form!"`
		fi	      
		exit
	fi
fi
	
